#########################################
### DimFBEinterf.py - threaded - StCl ###
#########################################

import threading
import time
import socket
import sys

aval = 1

cr = '\r'
lf = '\n'
crlf = cr + lf

tempval = 1000
ScanVal = 0

RcvLen = 50

def Test(inval):
    try:
	return inval
    except:
        print "Error: Test error"


def SendAndGetT(invals, setvals, ConvFun, RDBstuff):
    try:
        global aval
        if aval == 1:
            aval = 0
            
        else:
            RDBstuff('SendAndGetT socket locked', '*', '@')
            return -20        
        
        th = threading.Thread(target=SendAndGet, args=(invals, setvals, ConvFun, RDBstuff ))
        th.start()
        return 1
    except:
        RDBstuff('SendAndGetT threading error', '*', 'X')
        aval = 1
        return -30
        

def SendAndGet(invals, setvals, ConvFun, RDBstuff):
    global aval
    try:
        IP = setvals[0]
        PORT = int(setvals[1])
        server_address = (IP, PORT)
    except:
        RDBstuff('SendAndGet socket wrong params', '*', 'X')
        return -1
    
    try:
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        sock.settimeout(10)     
    except:
        RDBstuff('SendAndGet socket error', '*', 'X')
        aval = 1
        return -2
    
    try:
        sock.connect(server_address)
                
    except:
        RDBstuff('SendAndGet connect error','*','X')
        sock.close()
        aval = 1
        return -3

    try:
        ArgNum = len(invals)
        message = invals[0]
    except:
        RDBstuff('SendAndGet command error','*','X')
        sock.close()
        aval = 1
        return -4
    
    try:
        sock.sendall(message.encode())
    except:
        RDBstuff('SendAndGet sendall error','*','X')
        sock.close()
        aval = 1
        return -5
    
    for answs in range(1, ArgNum):
        receiving = True
        received = 0
        buf = ''
        while receiving:
            data = sock.recv(RcvLen)
            received += len(data)
            buf = buf + data.decode()
            if (buf.find(crlf) != -1):
                receiving = False
        RDBstuff('*',buf,'*')

    sock.close()
    aval = 1
    tempval = ConvFun(buf)     
    RDBstuff('*','*', tempval)
    return 0







